﻿using UnityEngine;
using System.Collections;

public class AirportFlocker : MonoBehaviour {

	float speed = 50f;
	float rangeToAirport = 50f;
	float rangeToFlockers = 40f;

	public SkyCity airport;

	void Start() {
		airport.RegisterFlocker(this);
	}

	void FixedUpdate() {
		Vector3 dir = Vector3.zero;

		Vector3 diff = this.transform.position - airport.transform.position;
		diff.y = 0;

		Vector3 correctSpot = airport.transform.position + diff.normalized*rangeToAirport;
		diff = this.transform.position - correctSpot;
		diff.y = 0;
		float dist = diff.magnitude;

		float strength = dist;
		if(strength > speed)
			strength = speed;
		dir = diff.normalized * -strength;


		foreach(AirportFlocker af in airport.flockers) {
			if(af != this) {
				diff = this.transform.position - af.transform.position;
				diff.y = 0;
				dist = diff.magnitude;
				if(dist == 0) {
					diff = Random.insideUnitSphere;
					diff.y = 0;
					dist = diff.magnitude;
				}

				if(dist < rangeToFlockers) {
					strength = 10000f / (dist*dist);
					if(strength > speed)
						strength = speed;

					dir += diff.normalized * strength;
				}
			}
		}

		transform.position = transform.position + dir*Time.deltaTime;

	}
}
