﻿using UnityEngine;
using System.Collections;

public class MoneyManager : MonoBehaviour {

	public static int skybucks = 10000;

	public UILabel skybucksLabel;
	public UILabel populationLabel;

	SkyCity[] cities;

	float taxCooldown = 2.5f;

	// Use this for initialization
	void Start () {
		cities = GameObject.FindObjectsOfType<SkyCity>();
	}
	
	// Update is called once per frame
	void Update () {
		int pop = 0;
		int taxAmount = 0;
		foreach(SkyCity c in cities) {
			pop += c.GetPopulation();
			taxAmount += Mathf.FloorToInt(c.GetPopulation() * c.taxRate / 10f);
		}

		if(pop >= 1000000) {
			DialogBox.ShowScript("Victory!", true);
		}

		if(taxAmount > 999999)
			taxAmount = 999999;

		taxCooldown -= Time.deltaTime;

		if(taxCooldown <= 0) {
			taxCooldown = 5f;
			skybucks += taxAmount;
		}

		if(skybucks > 999999999)
			skybucks = 999999999;

		skybucksLabel.text = "$" + string.Format ("{0:n0}", skybucks);
		populationLabel.text = "Population: " + string.Format ("{0:n0}", pop);
	}
}
