﻿using UnityEngine;
using System.Collections.Generic;

public class NewZeppelinWindow : MonoBehaviour {

	public GameObject zeppelinPrefab;

	List<ResourceStorage> stops;

	static List<Transform> zeppelins;

	const int baseZeppCost = 2500;

	public void CityClicked(GameObject go) {
		if(stops==null)
			stops = new List<ResourceStorage>();

		ResourceStorage stop = go.GetComponent<ResourceStorage>();

		if(stops.Count > 0 && stops[stops.Count-1] == stop) {
			return;
		}

		/*if(stops.Contains(stop)) {
			stops.Remove(stop);
		}
		else {
			stops.Add(stop);
		}*/


		stops.Add(stop);
		UpdateTexts();

	}

	int NextZeppCost() {
		if(zeppelins==null)
			zeppelins = new List<Transform>();

		if(zeppelins.Count==0)
			return 0;

		return Mathf.FloorToInt( baseZeppCost * Mathf.Pow(1.2f, zeppelins.Count-1 ) );
	}

	static public int SellZeppAmt() {
		if(zeppelins==null)
			zeppelins = new List<Transform>();

		if(zeppelins.Count==1)
			return 0;

		return Mathf.FloorToInt( baseZeppCost * Mathf.Pow(1.2f, zeppelins.Count-2 ) * 0.75f );
	}

	static public void SellZepp(GameObject zepp) {
		MoneyManager.skybucks += SellZeppAmt();
		zeppelins.Remove(zepp.transform);
		Destroy (zepp);
	}

	public void UpdateTexts() {
		if(stops==null)
			stops = new List<ResourceStorage>();


		Transform Cost = transform.Find ("Cost");
		string c = NextZeppCost().ToString();
		if(c=="0")
			c = "First one is free!";
		Cost.GetComponent<UILabel>().text = "Cost: " + c;


		Transform City1 = transform.Find ("City1");
		if(stops.Count > 0) {
			string s = "";
			foreach(ResourceStorage a in stops) {
				if(s.Length > 0) 
					s += ", ";
				
				s += a.gameObject.name;
			}
			
			City1.GetComponent<UILabel>().text = "Stops: " + s;
		}
		else {
			City1.GetComponent<UILabel>().text = "Click a building to add to the queue!";
		}
		
		Transform Ok = transform.Find ("Ok");
		Transform NoCash = transform.Find ("NoCash");
		Transform City2 = transform.Find ("City2");
		if(stops.Count >= 2) {
			//City2.GetComponent<UILabel>().text = "Right-click to remove the last entry!";
			City2.gameObject.SetActive(false);

			if(MoneyManager.skybucks >= NextZeppCost()) {
				Ok.gameObject.SetActive(true);
				NoCash.gameObject.SetActive(false);
			}
			else {
				Ok.gameObject.SetActive(false);
				NoCash.gameObject.SetActive(true);

			}
		}
		else {
			//City2.GetComponent<UILabel>().text = "Need at least two stops!";
			City2.gameObject.SetActive(true);
			Ok.gameObject.SetActive(false);
			NoCash.gameObject.SetActive(false);
		}


		Transform undo = transform.Find ("Undo");
		if(stops.Count >= 1) {
			undo.gameObject.SetActive(true);
		}
		else {
			undo.gameObject.SetActive(false);
		}


	}

	void Update() {
		UpdateTexts();
	}

	public void RemoveLast() {
		if(stops != null && stops.Count > 0) {
			stops.RemoveAt(stops.Count-1);
			UpdateTexts();
		}
	}


	public void OnCancel() {
		stops = null;
		gameObject.SetActive(false);
		AirportClickHandler.clickAction = null;
	}

	public void OnOk() {
		MoneyManager.skybucks -= NextZeppCost();
		Vector3 pos = stops[0].transform.position;
		pos.y = 0;

		string n = transform.Find("Zeppelin Name").GetComponent<UIInput>().value;

		GameObject zepp = (GameObject)Instantiate(zeppelinPrefab, pos, Quaternion.identity);
		zepp.name = n;
		zeppelins.Add(zepp.transform);
		Route r = zepp.GetComponent<Route>();
		r.stops = stops.ToArray();
		stops = null;
		gameObject.SetActive(false);
		AirportClickHandler.clickAction = null;
	}
}
