﻿using UnityEngine;
using System.Collections;

public class PositionShifter : MonoBehaviour {

	public Vector3 limit = Vector3.one;
	public float speed = 2f;
	public float changeDirTime = 1f;
	float nextChange = 0;
	Vector3 velocity = Vector3.zero;
	Vector3 offset = Vector3.zero;

	Vector3 origin;

	// Use this for initialization
	void Start () {
		origin = transform.position;
	}
	
	// Update is called once per frame
	void Update () {
		nextChange -= Time.deltaTime;
		if(nextChange <= 0) {
			nextChange = changeDirTime * Random.Range(0.5f, 1.5f);

			velocity = Random.insideUnitSphere * speed;
		}

		offset += velocity * Time.deltaTime;

		offset = new Vector3(
			Mathf.Clamp(offset.x, -limit.x, limit.x),
			Mathf.Clamp(offset.y, -limit.y, limit.y),
			Mathf.Clamp(offset.z, -limit.z, limit.z)
			);
		transform.position = origin + offset;
	}
}
