﻿using UnityEngine;
using System.Collections;

[RequireComponent(typeof(ResourceStorage))]
public class ResourceConsumer : MonoBehaviour {

	ResourceStorage rs;

	public string[] inputNames;

	public string outputName = "Ore";

	public float  rate = 1.0f;

	[System.NonSerialized]
	public int upgradeLevel = 0;

	float cooldown;

	// Use this for initialization
	void Start () {
		rs = GetComponent<ResourceStorage>();
		cooldown = rate;
	}

	public int UpgradeCost() {
		return Mathf.FloorToInt( 5000 * Mathf.Pow(2f, upgradeLevel) );
	}

	public void DoUpgrade() {
		//MoneyManager.skybucks -= UpgradeCost();
		upgradeLevel++;
		rate /= 1.5f;
	}

	// Update is called once per frame
	void Update () {

		if( SufficientInputs() && rs.GetResource(outputName) < rs.storageLimit ) {
			cooldown -= Time.deltaTime;

			if(cooldown <= 0) {
				cooldown = rate;
				ConsumeInputs();

				if(outputName != null && outputName.Length > 0) {
					rs.ChangeResource(outputName, 1f);
				}
				else {
					Debug.Log ("TODO: This is city, so grow me maybe?");
				}
			}
		}


	}

	bool SufficientInputs() {
		if(inputNames==null || inputNames.Length==0)
			return true;
		
		foreach(string i in inputNames) {
			if(rs.GetResource(i) <= 0) {
				return false;
			}
		}
		
		return true;
	}

	void ConsumeInputs() {
		if(inputNames==null) {
			return;
		}
		
		foreach(string i in inputNames) {
			rs.ChangeResource(i, -1f);
		}
	}
}
