﻿using UnityEngine;
using System.Collections.Generic;
using System.Linq;

public class SkydockInfoWindow : MonoBehaviour {

	void Update () {
		if( AirportClickHandler.selectedAirport != null ) {

			transform.Find ("Name").GetComponent<UILabel>().text = "Skydock: " + AirportClickHandler.selectedAirport.name;

			SkyCity skyCity = AirportClickHandler.selectedAirport.GetComponent<SkyCity>();
			if(skyCity != null) {
				transform.Find ("Population").gameObject.SetActive(true);
				transform.Find ("Population").GetComponent<UILabel>().text = "Pop: " + string.Format("{0:n0}", skyCity.GetPopulation());
				transform.Find ("Tax").gameObject.SetActive(true);
				transform.Find ("Tax").GetComponent<UILabel>().text = "Tax: " + string.Format("{0:n0}%", (skyCity.taxRate-1f)*100f);
			}
			else {
				transform.Find ("Population").gameObject.SetActive(false);
				transform.Find ("Tax").gameObject.SetActive(false);
			}

			ResourceConsumer rc = AirportClickHandler.selectedAirport.GetComponent<ResourceConsumer>();

			if(rc==null) {
				transform.Find ("Upgrade Button").gameObject.SetActive(false);
			}
			else {
				float perMin1 = 60f/rc.rate;
				float perMin2 = perMin1 * 1.5f;
				int cost = rc.UpgradeCost();

				transform.Find ("Upgrade Button").gameObject.SetActive(true);
				transform.Find ("Upgrade Button").Find ("Label").GetComponent<UILabel>().text = "Upgrade from\n"+
						string.Format("{0:n0}", perMin1)+"/min to "+
						string.Format("{0:n0}", perMin2)+"/min\n$"+
						string.Format("{0:n0}", cost);
			}


			transform.Find ("Cargo").GetComponent<UILabel>().text = "Cargo: " + AirportClickHandler.selectedAirport.GetComponent<ResourceStorage>().ToString();

			Dictionary<string, float> demands = AirportClickHandler.selectedAirport.GetComponent<ResourceStorage>().demands;

			List<string> cargoByDemand = demands.Keys.OrderByDescending( o => demands[o] ).ToList();

			for(int i=0; i<5; i++) {

				if(cargoByDemand.Count > i) {
					transform.Find ("Demand"+i).gameObject.SetActive(true);
					transform.Find ("Supply"+i).gameObject.SetActive(true);
					transform.Find ("Demand"+i).GetComponent<UILabel>().text = cargoByDemand[i] + ": " + demands[ cargoByDemand[i] ].ToString("F");
					transform.Find ("Supply"+i).GetComponent<UILabel>().text = cargoByDemand[cargoByDemand.Count - i - 1] + ": " + demands[ cargoByDemand[cargoByDemand.Count - i - 1] ].ToString("F");
				}
				else {
					transform.Find ("Demand"+i).gameObject.SetActive(false);
					transform.Find ("Supply"+i).gameObject.SetActive(false);
				}
			}


		}
		else {
			gameObject.SetActive(false);
		}
	}

	public void CloseButton() {
		AirportClickHandler.selectedAirport = null;
		gameObject.SetActive(false);
	}

	public void UpgradeButton() {
		ResourceConsumer[] rcs = AirportClickHandler.selectedAirport.GetComponents<ResourceConsumer>();

		if(rcs==null || rcs.Length==0)
			return;

		if(rcs[0].UpgradeCost() > MoneyManager.skybucks)
			return;

		MoneyManager.skybucks -= rcs[0].UpgradeCost();

		foreach(ResourceConsumer rc in rcs) {
			rc.DoUpgrade();
		}

	}

}
