﻿using UnityEngine;
using System.Collections.Generic;
using System.Linq;

public class ZeppelinInfoWindow : MonoBehaviour {

	void Update () {
		if( ZeppelinClickHandler.selectedZeppelin != null ) {
			
			transform.Find ("Name").GetComponent<UILabel>().text = ZeppelinClickHandler.selectedZeppelin.name;
			transform.Find ("Route").GetComponent<UILabel>().text = "Route: " + ZeppelinClickHandler.selectedZeppelin.GetComponent<Route>().ToString();
			transform.Find ("Cargo").GetComponent<UILabel>().text = "Cargo: " + ZeppelinClickHandler.selectedZeppelin.GetComponent<ResourceStorage>().ToString();

			Transform sellButton = transform.Find ("Sell Button");
			sellButton.Find("Label").GetComponent<UILabel>().text = "Sell for:\n" + NewZeppelinWindow.SellZeppAmt();

			Dictionary<string, float> demands = ZeppelinClickHandler.selectedZeppelin.GetComponent<ResourceStorage>().demands;

			transform.Find ("Upgrade Button").Find ("Label").GetComponent<UILabel>().text = "Upgrade ALL Zeppelin Speeds:\n" + ZeppSpeedUpgradeCost();

		}
		else {
			gameObject.SetActive(false);
		}
	}

	public void CloseButton() {
		ZeppelinClickHandler.selectedZeppelin = null;
		gameObject.SetActive(false);
	}

	public void SellButton() {
		if( ZeppelinClickHandler.selectedZeppelin != null ) {
			NewZeppelinWindow.SellZepp(ZeppelinClickHandler.selectedZeppelin.gameObject);
			ZeppelinClickHandler.selectedZeppelin = null;
		}
	}

	public int ZeppSpeedUpgradeCost() {
		return Mathf.FloorToInt( 10000 * Mathf.Pow( 2, SeeksPosition.speed/40 ) );
	}

	public void UpgradeZeppelins() {
		if(MoneyManager.skybucks >= ZeppSpeedUpgradeCost()) {
			MoneyManager.skybucks -= ZeppSpeedUpgradeCost();
			SeeksPosition.speed *= 1.25f;
		}
	}
}
